* Exec definitions

Execbase	EQU 4		* base of exec functions
ExecBase	EQU 4
OpenLibrary	EQU -408

* Graphic library bits
FreeSprite	EQU -414
OwnBlitter	EQU -432

*** dos offsets
Open		EQU -30
Close		EQU -36
Read		EQU -42
Write		EQU -48
Delay		EQU -198

* Amiga graphics definitions
CUSTOM		EQU $dff000	* custom chip base

BPLCON0		EQU $dff100	* bit plane control
BPLCON1		EQU $dff102	* scroll reg
BPLCON2		EQU $dff104	* priority

BPL1MOD		EQU $dff108	* modulus
BPL2MOD		EQU $dff10a	* modulus

DDFSTRT		EQU $dff092
DDFSTOP		EQU $dff094
DIWSTRT		EQU $dff08E
DIWSTOP		EQU $dff090		
VPOSR			EQU $dff004	* lsb if vertical pos
VHPOSR		EQU $dff006	* vertical pos of beam
COLOR0		EQU $dff180	* base of palette table
DMACONR		EQU $dff002
DMACONW		EQU $dff096

BPL1PTH		EQU $dff0E0	* bit plane 1

BPL2PTH		EQU $dff0E4	* bit plane 2

BPL3PTH		EQU $dff0e8	* bit plane 3

BPL4PTH		EQU $dff0ee	* bit plane 4

INTREQR		EQU $dff01e	* interrupt requests (read)
INTENAR		EQU $dff01c	* enable read
INTREQ		EQU $dff09c	* int req write
INTENA		EQU $dff09a	* interrupt enable

JOY0DAT		EQU $dff00a	* joystick 0 offset
JOY1DAT		EQU $dff00c	* joystick data offset

COP1LCH		EQU $dff080	* copper list latch
COPJMP1		EQU $dff088

SPR0PTH		EQU $dff120	* sprite 0 pointer
SPR0POS		EQU $dff140	* start of sprite controls

**** blitter consts *****
BLTCON0		EQU $dff040	* control 0
BLTCON1		EQU $dff042	* control 1
BLTAFWM		EQU $dff044	* mask A high
BLTALWM		EQU $dff046	* mask A low
BLTCPTH		EQU $dff048	* pointer source C
BLTBPTH		EQU $dff04c	* pointer source B
BLTAPTH		EQU $dff050	* pointer source A
BLTDPTH		EQU $dff054	* pointer dest D
BLTSIZE		EQU $dff058	* w/h and start 
BLTCMOD		EQU $dff060	* modulo for C
BLTBMOD		EQU $dff062	*    "    "  B
BLTAMOD		EQU $dff064	*    "    "  A
BLTDMOD		EQU $dff066	*    "    "  D
BLTCDAT		EQU $dff070	* C data reg
BLTBDAT		EQU $dff072	* B   "   "
BLTADAT		EQU $dff074	* A   "   "

**** Audio constants ****
AUD0LCH		EQU $dff0a0	* audio data start
AUD1LCH		EQU $dff0b0	* audio data start
AUD2LCH		EQU $dff0c0	* audio data start
AUD3LCH		EQU $dff0d0	* audio data start

AUD0LEN		EQU $dff0a4	* audio data length (words)
AUD1LEN		EQU $dff0b4	* audio data length (words)
AUD2LEN		EQU $dff0c4	* audio data length (words)
AUD3LEN		EQU $dff0d4	* audio data length (words)

AUD0PER		EQU $dff0a6	* sample play rate
AUD1PER		EQU $dff0b6	* sample play rate
AUD2PER		EQU $dff0c6	* sample play rate
AUD3PER		EQU $dff0d6	* sample play rate

AUD0VOL		EQU $dff0a8	* volume 0-64
AUD1VOL		EQU $dff0b8	* volume 0-64
AUD2VOL		EQU $dff0c8	* volume 0-64
AUD3VOL		EQU $dff0d8	* volume 0-64

ADKCON		EQU $dff09e	* modulation control

* for lightgun *
POTGOR		EQU $dff016	* light port read
POTGO			EQU $dff034	* light port write

* constants common to ST aswell *
KeyAddr		EQU $bfec01
F1_key		EQU 95
F2_key		EQU 93
F3_key		EQU 91
F4_key		EQU 89
F5_key		EQU 87
F6_key		EQU 85
F7_key		EQU 83
F8_key		EQU 81
F9_key		EQU 79
F10_key		EQU 77
SPACE_BAR		EQU 127
***********************************************************